//---------------------------------------------------------------------------
#include <vcl\vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TGameForm.h"
#include "TMainForm.h"
#include "TPlayerSetupForm.h"
#include "TStatusForm.h"
#include "dos.h"
//---------------------------------------------------------------------------
#pragma link "TDPChat"
//---------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TGameForm *GameForm;
//---------------------------------------------------------------------------
__fastcall TGameForm::TGameForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::Button3Click(TObject *Sender)
{
if (MainForm->Dx_Play1->Created && (MainForm->NumPlayers>0))
	{
    // this is sending a text message using a normal Send() inside our custom data block
    // normally you would use SendChatMessage(), but twas just curious

    Message = (MessageStruct*) new char[MESSAGESTRUCT_HEADER_LENGTH + Edit2->Text.Length()+1 ];	// +1 == include trailing zero byte
    if (Message)
        {
        Message->Message_Type = PLAYER_TEXT_MESSAGE;
        Message->Message_Length = Edit2->Text.Length()+1;
        CopyMemory( &Message->Message_Data, Edit2->Text.c_str(), Message->Message_Length );

        MainForm->Dx_Play1->Send( MainForm->PlayerIDs[0], DPID_ALLPLAYERS, DPSEND_GUARANTEED, Message, Message->Message_Length );

        delete Message;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::Button4Click(TObject *Sender)
{
if (MainForm->Dx_Play1->Created && (MainForm->NumPlayers>0))
	{
    DPChat1->MessageA = Edit2->Text;
	MainForm->Dx_Play1->SendChatMessage( MainForm->PlayerIDs[0], DPID_ALLPLAYERS, DPSEND_GUARANTEED, DPChat1 );
    }
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::Button5Click(TObject *Sender)
{
dword message_id = 0;
if (MainForm->Dx_Play1->Created && (MainForm->NumPlayers>0))
	{
	MainForm->Dx_Play1->SendEx( MainForm->PlayerIDs[0], DPID_ALLPLAYERS, DPSEND_ASYNC, Edit2->Text.c_str(), Edit2->Text.Length()+1, 65535, 0, NULL, &message_id );
    }
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::FormShow(TObject *Sender)
{
Top=StatusForm->Height+1;
Left=PlayerSetupForm->Width+1;
Timer1->Enabled = true;
if (MainForm->I_Am_The_Host)
    MainForm->Game_Running = true;
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::PaintDot( int x, int y, TColor color )
{
for (int yy=-5;yy<5;yy++)
	for (int xx=-5;xx<5;xx++)
		Image1->Canvas->Pixels[x+xx][y+yy] = color;
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::Timer1Timer(TObject *Sender)
{
GameInfo.Is_Running = true;

if (MainForm->I_Am_The_Host)
	{
	// paint with blue each time we pick a new coord
	if (!GameInfo.Is_Flashing)
        {
        GameInfo.x = random( Image1->Width-10 )+5;
        GameInfo.y = random( Image1->Height-10 )+5;
        GameInfo.color = clBlue;
        GameInfo.Is_Hit = false;
        GameInfo.Is_Flashing = true;
        }
    else
        {
        // update the position of the last dot
        if (GameInfo.Is_Hit)
            {
            GameInfo.color = clGreen;
            }
        else
            GameInfo.color = clRed;

        GameInfo.Is_Hit = false;
        GameInfo.Is_Flashing = false;

        // make the game faster (up to a point)
        if (Timer1->Interval>400)
            {
            Timer1->Interval = Timer1->Interval - 5;
            GameInfo.Interval = Timer1->Interval;
            }
        }

    // tell other players the new coordinates, score, timer tick, and dot status
    if (MainForm->Dx_Play1->Created)
        if (MainForm->NumPlayers>0)
            {
            Message = (MessageStruct*) new char[MESSAGESTRUCT_HEADER_LENGTH + sizeof(GameInfoStruct)];
            if (Message)
                {
                Message->Message_Type = GAME_TICK_MESSAGE;
                Message->Message_Length = sizeof(GameInfoStruct);
                CopyMemory( &Message->Message_Data, &GameInfo, Message->Message_Length );

                MainForm->Dx_Play1->Send( MainForm->PlayerIDs[0], DPID_ALLPLAYERS, DPSEND_GUARANTEED, Message, Message->Message_Length );

                delete Message;
                }
            }
	}

// update the score display
PaintDot( GameInfo.x,GameInfo.y, GameInfo.color );

ScoreLabel->Caption = IntToStr((int) GameInfo.score);
ScoreLabel->Update();
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::Image1MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
if ((X>=5) && (X<=Image1->Width-5) &&
	(Y>=5) && (Y<=Image1->Height-5) &&
    (X>=GameInfo.x-5) && (X<=GameInfo.x+5) &&
    (Y>=GameInfo.y-5) && (Y<=GameInfo.y+5))
	{
    GameInfo.Is_Hit = true;
    GameInfo.Is_Flashing = false;
	GameInfo.color = clGreen;
	PaintDot( GameInfo.x,GameInfo.y, GameInfo.color );
    GameInfo.score = GameInfo.score + 50;
    }
else
	{
    GameInfo.Is_Hit = false;
	GameInfo.color = clRed;
	PaintDot( GameInfo.x,GameInfo.y, GameInfo.color );
    GameInfo.score = GameInfo.score - 20;
    }

// tell other players the new coordinates, score, timer tick, and dot status
if (MainForm->Dx_Play1->Created)
    if (MainForm->NumPlayers>0)
        {
        Message = (MessageStruct*) new char[MESSAGESTRUCT_HEADER_LENGTH + sizeof(GameInfoStruct)];
        if (Message)
            {
            Message->Message_Type = PLAYER_CLICK_MESSAGE;
            Message->Message_Length = sizeof(GameInfoStruct);
            GameInfo.x = X;
            GameInfo.y = Y;
            CopyMemory( &Message->Message_Data, &GameInfo, Message->Message_Length );

            MainForm->Dx_Play1->Send( MainForm->PlayerIDs[0], DPID_ALLPLAYERS, DPSEND_GUARANTEED, Message, Message->Message_Length );

            delete Message;
            }
        }
}
//---------------------------------------------------------------------------
void __fastcall TGameForm::FormHide(TObject *Sender)
{
Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
