//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include "TDx_Play.h"
#include "TDx_PlayLobby.h"
#include "TDPName.h"
#include "TDPSessionDesc.h"
#include "TDPCaps.h"
#include <vcl\ExtCtrls.hpp>
#include "TDPChat.h"
#include "TDPApplicationDesc.h"
#include "TDPLConnection.h"
#include "TDPLAppInfo.h"
#include "TDPCompoundAddressElement.h"
//---------------------------------------------------------------------------

#if (__BORLANDC__ < 0x0530) // BCB Version 1
class TMainForm : public TForm
{
#else // BCB Version 3+
class PACKAGE TMainForm : public TForm
{
#endif

__published:
//---------------------------------------------------------------------------
// Anything that is to be displayed within the Object Inspector
//---------------------------------------------------------------------------

	TDx_Play *Dx_Play1;
	TDPSessionDesc *DPSessionDesc1;
	TGroupBox *GroupBox2;
	TListBox *ConnectionsListBox;
	TLabel *SelectedConnectionLabel;
	TLabel *Label7;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn1;
	TLabel *Label8;
	TListBox *CapsListBox;
	TDPCaps *DPCaps1;
	TGroupBox *GroupBox3;
	TListBox *SessionsListBox;
	TLabel *Label12;
	TLabel *SelectedSessionLabel;
	TBitBtn *BitBtn6;
	TBitBtn *JoinSessionButton;
	TEdit *SessionNameEdit;
	TBitBtn *CreateSessionButton;
	TLabel *Label10;
	TLabel *Label15;
	TEdit *MaxPlayersEdit;
	TBitBtn *CloseSessionButton;
	void __fastcall Dx_Play1Error(TObject *Sender, AnsiString Function,
	AnsiString Error, AnsiString ErrorMessage);
	void __fastcall Dx_Play1EnumConnections(TObject *Sender, const GUID *SP,
	void *Connection, DWORD ConnectionSize, TDPName *Name, DWORD Flags,
	void *Context, bool &Continue);
	void __fastcall Dx_Play1EnumSessions(TObject *Sender, TDPSessionDesc *ThisSD,
	DWORD *TimeOut, DWORD Flags, void *Context, bool &Continue);
	void __fastcall BitBtn8Click(TObject *Sender);
	void __fastcall Dx_Play1Receive(TObject *Sender);
   void __fastcall CreateSessionButtonClick(TObject *Sender);
   void __fastcall Dx_Play1StartSession(TObject *Sender, TDPLConnection *Conn);
   void __fastcall Dx_Play1SessionLost(TObject *Sender);
   void __fastcall Dx_Play1Create(TObject *Sender);
   void __fastcall Dx_Play1Destroy(TObject *Sender);
   void __fastcall Dx_Play1Generic(TObject *Sender, DWORD From, DWORD To,
   DWORD Flags, void *Data, DWORD DataSize, DWORD MessageType);
   void __fastcall JoinSessionButtonClick(TObject *Sender);
	void __fastcall CloseSessionButtonClick(TObject *Sender);
	void __fastcall Dx_Play1AddGroupToGroup(TObject *Sender, DWORD IdParentGroup,
	DWORD IdGroup);
	void __fastcall Dx_Play1AddPlayerToGroup(TObject *Sender, DWORD IdParentGroup,
	DWORD IdGroup);
	void __fastcall Dx_Play1Chat(TObject *Sender, DWORD Flags, DWORD FromPlayer,
	DWORD ToPlayer, DWORD ToGroup, TDPChat *Chat);
	void __fastcall Dx_Play1CreatePlayerOrGroup(TObject *Sender, DWORD PlayerType,
	DWORD Id, DWORD CurrentPlayers, void *Data, DWORD DataSize, TDPName *Name,
	DWORD IdParent, DWORD Flags);
	void __fastcall Dx_Play1DeleteGroupFromGroup(TObject *Sender,
	DWORD IdParentGroup, DWORD IdGroup);
	void __fastcall Dx_Play1DeletePlayerFromGroup(TObject *Sender,
	DWORD IdParentGroup, DWORD IdGroup);
	void __fastcall Dx_Play1DestroyPlayerOrGroup(TObject *Sender, DWORD PlayerType,
	DWORD Id, void *LocalData, DWORD LocalDataSize, void *RemoteData,
	DWORD RemoteDataSize, TDPName *Name, DWORD IdParent, DWORD dwFlags);
	void __fastcall Dx_Play1EnumGroupPlayers(TObject *Sender, DWORD Id,
	DWORD PlayerType, TDPName *Name, DWORD Flags, void *Context, bool &Continue);
	void __fastcall Dx_Play1EnumGroups(TObject *Sender, DWORD Id, DWORD PlayerType,
	TDPName *Name, DWORD Flags, void *Context, bool &Continue);
	void __fastcall Dx_Play1EnumGroupsInGroup(TObject *Sender, DWORD Id,
	DWORD PlayerType, TDPName *Name, DWORD Flags, void *Context, bool &Continue);
	void __fastcall Dx_Play1EnumPlayers(TObject *Sender, DWORD Id,
	DWORD PlayerType, TDPName *Name, DWORD Flags, void *Context, bool &Continue);
	void __fastcall Dx_Play1Host(TObject *Sender);
	void __fastcall Dx_Play1SecureMessage(TObject *Sender, DWORD Flags,
	DWORD IdFrom, void *Data, DWORD DataSize);
	void __fastcall Dx_Play1SendComplete(TObject *Sender, DWORD From, DWORD To,
	DWORD Flags, DWORD Priority, DWORD Timeout, void *Context, DWORD MsgID,
	HRESULT hr, DWORD SendTime);
	void __fastcall Dx_Play1SetGroupOwner(TObject *Sender, DWORD Group,
	DWORD NewOwner, DWORD OldOwner);
	void __fastcall Dx_Play1SetPlayerOrGroupData(TObject *Sender, DWORD Flags,
	DWORD IdFrom, void *Data, DWORD DataSize);
	void __fastcall Dx_Play1SetPlayerOrGroupName(TObject *Sender, DWORD PlayerType,
	DWORD Id, TDPName *Name);
	void __fastcall Dx_Play1SetSessionDesc(TObject *Sender, TDPSessionDesc *Desc);
	void __fastcall ConnectionsListBoxClick(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall BitBtn6Click(TObject *Sender);
	void __fastcall MaxPlayersEditChange(TObject *Sender);
	void __fastcall SessionsListBoxClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
public:
//---------------------------------------------------------------------------
// Anything available to other classes and/or code
//---------------------------------------------------------------------------

    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();

    bool		I_Am_The_Host;
    bool		Game_Running;

	#define MAX_CONNECTIONS		20

	dword		NumConnections;
    GUID		ConnectionGuids[MAX_CONNECTIONS];
    void*		ConnectionBuffers[MAX_CONNECTIONS];
    dword		ConnectionSizes[MAX_CONNECTIONS];
    TDPName*	ConnectionNames[MAX_CONNECTIONS];
    dword		ConnectionFlags[MAX_CONNECTIONS];

    bool		ConnectionInitialized;

    #define MAX_SESSIONS		10

    dword		NumSessions;
    TDPSessionDesc*	Sessions[MAX_SESSIONS];
	bool		SessionOpen;

    #define MAX_APPLICATIONS 	100

    int			NumApplications;
	AnsiString	ApplicationNames[MAX_APPLICATIONS];
    GUID		ApplicationGuids[MAX_APPLICATIONS];
    dword		ApplicationIDs[MAX_APPLICATIONS];

    #define MAX_ADDRESSES		20

    int			NumAddresses;
    GUID		AddressGuids[MAX_ADDRESSES];
    dword		AddressFlags[MAX_ADDRESSES];

    #define MAX_PLAYERS			100

    int 		NumPlayers;
    DPID		PlayerIDs[MAX_PLAYERS];
    TDPName*	PlayerNames[MAX_PLAYERS];
    dword		PlayerPlayerTypes[MAX_PLAYERS];
    dword		PlayerFlags[MAX_PLAYERS];

    #define MAX_PLAYERS_IN_GROUPS		100

    int			NumPlayersInGroups;
    DPID		PlayerInGroupsIDs[MAX_PLAYERS];
    TDPName*	PlayerInGroupsNames[MAX_PLAYERS];
    dword		PlayerInGroupsPlayerTypes[MAX_PLAYERS];
    dword		PlayerInGroupsFlags[MAX_PLAYERS];

    #define MAX_GROUPS			10

    int 		NumGroups;
    DPID		GroupIDs[MAX_GROUPS];
    dword		GroupPlayerTypes[MAX_GROUPS];
    TDPName*	GroupNames[MAX_GROUPS];
    dword		GroupFlags[MAX_GROUPS];

    #define MAX_GROUPS_IN_GROUPS	10

    int 		NumGroupsInGroups;
    DPID		GroupsInGroupsIDs[MAX_GROUPS_IN_GROUPS];
    dword		GroupsInGroupsPlayerTypes[MAX_GROUPS_IN_GROUPS];
    TDPName*	GroupsInGroupsNames[MAX_GROUPS_IN_GROUPS];
    dword		GroupsInGroupsFlags[MAX_GROUPS_IN_GROUPS];


protected:
//---------------------------------------------------------------------------
// Anything available only to classes descended from this class
//---------------------------------------------------------------------------

private:
//---------------------------------------------------------------------------
// Private data not accessible except from within this class
//---------------------------------------------------------------------------

};
//---------------------------------------------------------------------------
#if (__BORLANDC__ < 0x0530) // BCB Version 1
extern TMainForm *MainForm;
#else // BCB Version 3+
extern PACKAGE TMainForm *MainForm;
#endif
//---------------------------------------------------------------------------
#endif
